#include "3dpoint.h"
#include <assert.h>

#include <stdio.h>
#include <math.h>

C3dpoint get_sensor_pos(
			int sensor_number
			)
{
  assert (NR_OF_SENSORS == 4);

  switch (sensor_number)
    {
    case 0 : return C3dpoint(             5,CUBE_SIZE-1-5,CUBE_SIZE-1-5);
    case 1 : return C3dpoint(CUBE_SIZE-1- 5,CUBE_SIZE-1-5,CUBE_SIZE-1-5);
    case 2 : return C3dpoint(            20,CUBE_SIZE-1-5,CUBE_SIZE-1-5);
    case 3 : return C3dpoint(CUBE_SIZE-1-20,CUBE_SIZE-1-5,CUBE_SIZE-1-5);
    default : assert(false); exit(1);
    };
};

C3dpoint get_wheel_pos(
		       int sensor_number
		       )
{
  assert (NR_OF_WHEELS == 2);

  switch (sensor_number)
    {
    case 0 : return C3dpoint(            5,5,5);
    case 1 : return C3dpoint(CUBE_SIZE-1-5,5,5);
    default : assert(false); exit(1);
    };
};

// ********************************************************************
// ************************** C3dpoint ********************************
// ********************************************************************
C3dpoint::C3dpoint(
		   int x,
		   int y,
		   int z
		   )
{
    assert(x >= 0); assert(x < CUBE_SIZE);
    assert(y >= 0); assert(y < CUBE_SIZE);
    assert(z >= 0); assert(z < CUBE_SIZE);

    _x = x;
    _y = y;
    _z = z;

    initialized=true;
};
    
C3dpoint::C3dpoint(
		   MyBitString genotype
		   )
{
    assert(genotype.length() == GENOTYPE_LENGTH_POSITION);

    _x = genotype.value_at(0                                         , GENOTYPE_LENGTH_POSITION_ONE_COORDINATE);
    _y = genotype.value_at(GENOTYPE_LENGTH_POSITION_ONE_COORDINATE   , GENOTYPE_LENGTH_POSITION_ONE_COORDINATE);
    _z = genotype.value_at(GENOTYPE_LENGTH_POSITION_ONE_COORDINATE*2 , GENOTYPE_LENGTH_POSITION_ONE_COORDINATE);

    initialized=true;
};

C3dpoint::C3dpoint()
{
    initialized = false;
};
    
C3dpoint::~C3dpoint()
{
    // nothing to be done;
}

int C3dpoint::x()
{
    assert(initialized);
    return _x;
};

int C3dpoint::y()
{
    assert(initialized);
    return _y;
};

int C3dpoint::z()
{
    assert(initialized);
    return _z;
};
