#ifndef __BRAIN_H
#define __BRAIN_H

// #include "growingaxonhead.h" //tmp

#include "constants.h"
#include "growinggrid.h"
#include "growingcell.h"
#include "growingaxonlist.h"
#include "3dpoint.h"
#include "MyBitString.h"
#include "cell.h"

class CBrain{
 private:
    MyBitString genotype;
    float       ANN[NR_OF_CONNECTABLE_CELLS][NR_OF_CONNECTABLE_CELLS];
    // connection   ^^^^^^^^^dest^^^^^^^^^^  ^^^^^^^^^source^^^^^^^^
    // indizes:
    // first the sensors, then the wheels and at last the neurons

    CCell      *cells[NR_OF_CONNECTABLE_CELLS];

    CSensor     sensors[NR_OF_SENSORS];
    CWheel      wheels[NR_OF_WHEELS];
    CNeuron     neurons[NR_OF_NEURONS];
    
 protected:
    void load_sensors(
		      float input[NR_OF_SENSORS]
		      );

    void compute();

    void get_wheels(
		    float output[NR_OF_WHEELS]
		    );
 public:
    CBrain(
	   MyBitString igenotype
	   );
    ~CBrain();

    void get_genotype(
		      MyBitString &igenotype
		      );
};

#endif // __BRAIN_H
