#ifndef __CREATURE_H
#define __CREATURE_H

#include "brain.h"
#include "constants.h"
#include "MyBitString.h"

class CCreature : public CBrain{
 private:
    int     energy;
    float   xpos,ypos,direction;
 public:
    CCreature(
	      MyBitString igenotype,
	      float ix,
              float iy,
	      float id
	      );
    ~CCreature();
    
    void move(
	      float input[NR_OF_SENSORS]
	      );

    float get_x();
    float get_y();
    float get_direction();

    void set_x(float in);
    void set_y(float in);
    void set_direction(float in);            // direction in rad and counter-clockwise
                                             // 0 is "to top" = positive y and no x
		                             // pi/2 is "to left" = no y and negative x
    
    // those change energy:
    void live_cycle();
    void eat();
    void crash();
    
    bool alive();
};

#endif // __CREATURE_H
