#ifndef __WORLD_H
#define __WORLD_H

#include "constants.h"
#include "creature.h"
#include "MyBitString.h"

class CWorld {
private:
    int world_x_size;
    int world_y_size;
    int **empty_world;
    int **world;

    float eye(
	      float x,
	      float y,
	      float direction
	      );
    float whisker(
		  int x,
		  int y,
		  float direction
		  );
public:
    CWorld(
	   const char *map_name
	   );
    
    ~CWorld();
    
    void read_new_map(
		      const char *map_name
		      );

    void evaluate(
		  MyBitString *genotypes[POPULATION_SIZE]
		  );

};

#endif //__WORLD_H
