#ifndef __WORLDVIEWER_H
#define __WORLDVIEWER_H

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xresource.h>
#include <X11/keysym.h>

#include <math.h>

#include "constants.h"
#include "world.h"
#include "creature.h"

class CWorld_Viewer {

private:
    void init_windows(int xs, int ys);
    void setUpGCs();

    void rectangle(int x, int y);

protected:
    /* The basic set of header files for any Xlib program */
    Display *display;  /* Server or display to which a connection will be made */
    int screen;        /* Screen number to use on that display */
    Window win;        /* The applications one and only window */
    XEvent event;      /* The event data structure */
    GC gc1, gc2;       /* Graphics context data structures */
    XGCValues gs1,gs2; /* Graphics context settings */

    bool initialized;

    void drawInToWindow(int &xs, int &ys, int **&world, CCreature *Creatures[]);

public:
    CWorld_Viewer();
    ~CWorld_Viewer();
    void show(int &xs, int &ys, int **&world, CCreature *Creatures[]);
};

#endif // __WORLDVIEWER_H
